// Code generated by wsdl2go. DO NOT EDIT.

package wsdl

import (
	"reflect"

	"github.com/fiorix/wsdl2go/soap"
)

// Namespace was auto-generated from WSDL.
var Namespace = "http://tempuri.org/"

// NewICoverIntegrationService creates an initializes a ICoverIntegrationService.
func NewICoverIntegrationService(cli *soap.Client) ICoverIntegrationService {
	return &iCoverIntegrationService{cli}
}

// ICoverIntegrationService was auto-generated from WSDL
// and defines interface for the remote service. Useful for testing.
type ICoverIntegrationService interface {
	// DownloadMessageChunk was auto-generated from WSDL.
	DownloadMessageChunk(DownloadMessageChunk *DownloadMessageChunk) (*DownloadMessageChunkResponse, error)

	// EndProcessingDownloadedMessage was auto-generated from WSDL.
	EndProcessingDownloadedMessage(EndProcessingDownloadedMessage *EndProcessingDownloadedMessage) (*EndProcessingDownloadedMessageResponse, error)

	// GetHistory was auto-generated from WSDL.
	GetHistory(GetHistory *GetHistory) (*GetHistoryResponse, error)

	// GetInputMessages was auto-generated from WSDL.
	GetInputMessages(GetInputMessages *GetInputMessages) (*GetInputMessagesResponse, error)

	// GetMessageValidationInfo was auto-generated from WSDL.
	GetMessageValidationInfo(GetMessageValidationInfo *GetMessageValidationInfo) (*GetMessageValidationInfoResponse, error)

	// GetSessionInfo was auto-generated from WSDL.
	GetSessionInfo(GetSessionInfo *GetSessionInfo) (*GetSessionInfoResponse, error)

	// GetSessionsInfo was auto-generated from WSDL.
	GetSessionsInfo(GetSessionsInfo *GetSessionsInfo) (*GetSessionsInfoResponse, error)

	// GetVersion was auto-generated from WSDL.
	GetVersion(GetVersion *GetVersion) (*GetVersionResponse, error)

	// OpenDownloadingSession was auto-generated from WSDL.
	OpenDownloadingSession(OpenDownloadingSession *OpenDownloadingSession) (*OpenDownloadingSessionResponse, error)

	// OpenUploadingSession was auto-generated from WSDL.
	OpenUploadingSession(OpenUploadingSession *OpenUploadingSession) (*OpenUploadingSessionResponse, error)

	// UploadMessageChunk was auto-generated from WSDL.
	UploadMessageChunk(UploadMessageChunk *UploadMessageChunk) (*UploadMessageChunkResponse, error)
}

// DateTime in WSDL format.
type DateTime string

// DataTransferFormat was auto-generated from WSDL.
type DataTransferFormat string

// Validate validates DataTransferFormat.
func (v DataTransferFormat) Validate() bool {
	for _, vv := range []string{
		"Plain",
		"SevenZipArchive",
	} {
		if reflect.DeepEqual(v, vv) {
			return true
		}
	}
	return false
}

// MessageCreator was auto-generated from WSDL.
type MessageCreator string

// Validate validates MessageCreator.
func (v MessageCreator) Validate() bool {
	for _, vv := range []string{
		"Sed",
		"Sev",
	} {
		if reflect.DeepEqual(v, vv) {
			return true
		}
	}
	return false
}

// MessageType was auto-generated from WSDL.
type MessageType string

// Validate validates MessageType.
func (v MessageType) Validate() bool {
	for _, vv := range []string{
		"Notification",
		"Document",
		"DocumentAddition",
		"ReplayDocument",
		"ReplayDocumentAddition",
	} {
		if reflect.DeepEqual(v, vv) {
			return true
		}
	}
	return false
}

// SessionStatus was auto-generated from WSDL.
type SessionStatus string

// Validate validates SessionStatus.
func (v SessionStatus) Validate() bool {
	for _, vv := range []string{
		"Opened",
		"InProgress",
		"Processed",
		"Failed",
		"Delivered",
	} {
		if reflect.DeepEqual(v, vv) {
			return true
		}
	}
	return false
}

// SessionType was auto-generated from WSDL.
type SessionType string

// Validate validates SessionType.
func (v SessionType) Validate() bool {
	for _, vv := range []string{
		"Upload",
		"Download",
	} {
		if reflect.DeepEqual(v, vv) {
			return true
		}
	}
	return false
}

// Char was auto-generated from WSDL.
type Char int

// todo: maybe should be deleted
// Duration was auto-generated from WSDL.
// type Duration Duration

// Guid was auto-generated from WSDL.
type Guid string

// ArrayOfMessageInfo was auto-generated from WSDL.
type ArrayOfMessageInfo struct {
	MessageInfo []*MessageInfo `xml:"cover:MessageInfo,omitempty" json:"MessageInfo,omitempty" yaml:"MessageInfo,omitempty"`
}

// ArrayOfSessionInfo was auto-generated from WSDL.
type ArrayOfSessionInfo struct {
	SessionInfo []*SessionInfo `xml:"cover:SessionInfo,omitempty" json:"SessionInfo,omitempty" yaml:"SessionInfo,omitempty"`
}

// ArrayOflong was auto-generated from WSDL.
type ArrayOflong struct {
	Long []*int64 `xml:"long,omitempty" json:"long,omitempty" yaml:"long,omitempty"`
}

// CommunicationError was auto-generated from WSDL.
type CommunicationError struct {
	Code *int    `xml:"cover:Code,omitempty" json:"Code,omitempty" yaml:"Code,omitempty"`
	Text *string `xml:"cover:Text,omitempty" json:"Text,omitempty" yaml:"Text,omitempty"`
}

// DownloadChunkResponse was auto-generated from WSDL.
type DownloadChunkResponse struct {
	MessageChunk *[]byte      `xml:"cover:MessageChunk,omitempty" json:"MessageChunk,omitempty" yaml:"MessageChunk,omitempty"`
	Session      *SessionInfo `xml:"cover:Session,omitempty" json:"Session,omitempty" yaml:"Session,omitempty"`
}

// DownloadMessageChunk was auto-generated from WSDL.
type DownloadMessageChunk struct {
	Identity     *Identity `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	SessionId    *int64    `xml:"sessionId,omitempty" json:"sessionId,omitempty" yaml:"sessionId,omitempty"`
	FromPosition *int64    `xml:"fromPosition,omitempty" json:"fromPosition,omitempty" yaml:"fromPosition,omitempty"`
	Count        *int64    `xml:"count,omitempty" json:"count,omitempty" yaml:"count,omitempty"`
}

// DownloadMessageChunkResponse was auto-generated from WSDL.
type DownloadMessageChunkResponse struct {
	DownloadMessageChunkResult *DownloadChunkResponse `xml:"tem:DownloadMessageChunkResult,omitempty" json:"DownloadMessageChunkResult,omitempty" yaml:"DownloadMessageChunkResult,omitempty"`
}

// EndProcessingDownloadedMessage was auto-generated from WSDL.
type EndProcessingDownloadedMessage struct {
	Identity    *Identity    `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	SessionInfo *SessionInfo `xml:"sessionInfo,omitempty" json:"sessionInfo,omitempty" yaml:"sessionInfo,omitempty"`
}

// EndProcessingDownloadedMessageResponse was auto-generated from
// WSDL.
type EndProcessingDownloadedMessageResponse struct {
	EndProcessingDownloadedMessageResult *SessionInfo `xml:"tem:EndProcessingDownloadedMessageResult,omitempty" json:"EndProcessingDownloadedMessageResult,omitempty" yaml:"EndProcessingDownloadedMessageResult,omitempty"`
}

// GetHistory was auto-generated from WSDL.
type GetHistory struct {
	Identity     *Identity `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	FromDateTime *DateTime `xml:"fromDateTime,omitempty" json:"fromDateTime,omitempty" yaml:"fromDateTime,omitempty"`
	ToDateTime   *DateTime `xml:"toDateTime,omitempty" json:"toDateTime,omitempty" yaml:"toDateTime,omitempty"`
	Count        *int      `xml:"count,omitempty" json:"count,omitempty" yaml:"count,omitempty"`
}

// GetHistoryResponse was auto-generated from WSDL.
type GetHistoryResponse struct {
	GetHistoryResult *ArrayOfMessageInfo `xml:"GetHistoryResult,omitempty" json:"GetHistoryResult,omitempty" yaml:"GetHistoryResult,omitempty"`
}

// GetInputMessages was auto-generated from WSDL.
type GetInputMessages struct {
	Identity *Identity `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	Ount     *int      `xml:"сount,omitempty" json:"сount,omitempty" yaml:"сount,omitempty"`
}

// GetInputMessagesResponse was auto-generated from WSDL.
type GetInputMessagesResponse struct {
	GetInputMessagesResult *ArrayOfMessageInfo `xml:"tem:GetInputMessagesResult,omitempty" json:"GetInputMessagesResult,omitempty" yaml:"GetInputMessagesResult,omitempty"`
}

// GetMessageValidationInfo was auto-generated from WSDL.
type GetMessageValidationInfo struct {
	Identity  *Identity `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	SessionId *int64    `xml:"sessionId,omitempty" json:"sessionId,omitempty" yaml:"sessionId,omitempty"`
}

// GetMessageValidationInfoResponse was auto-generated from WSDL.
type GetMessageValidationInfoResponse struct {
	GetMessageValidationInfoResult *MessageValidationInfo `xml:"tem:GetMessageValidationInfoResult,omitempty" json:"GetMessageValidationInfoResult,omitempty" yaml:"GetMessageValidationInfoResult,omitempty"`
}

// GetSessionInfo was auto-generated from WSDL.
type GetSessionInfo struct {
	Identity  *Identity `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	SessionId *int64    `xml:"sessionId,omitempty" json:"sessionId,omitempty" yaml:"sessionId,omitempty"`
}

// GetSessionInfoResponse was auto-generated from WSDL.
type GetSessionInfoResponse struct {
	GetSessionInfoResult *SessionInfo `xml:"tem:GetSessionInfoResult,omitempty" json:"GetSessionInfoResult,omitempty" yaml:"GetSessionInfoResult,omitempty"`
}

// GetSessionsInfo was auto-generated from WSDL.
type GetSessionsInfo struct {
	Identity    *Identity    `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	SessionsIds *ArrayOflong `xml:"sessionsIds,omitempty" json:"sessionsIds,omitempty" yaml:"sessionsIds,omitempty"`
}

// GetSessionsInfoResponse was auto-generated from WSDL.
type GetSessionsInfoResponse struct {
	GetSessionsInfoResult *ArrayOfSessionInfo `xml:"tem:GetSessionsInfoResult,omitempty" json:"GetSessionsInfoResult,omitempty" yaml:"GetSessionsInfoResult,omitempty"`
}

// GetVersion was auto-generated from WSDL.
type GetVersion struct {
}

// GetVersionResponse was auto-generated from WSDL.
type GetVersionResponse struct {
	GetVersionResult *string `xml:"tem:GetVersionResult,omitempty" json:"GetVersionResult,omitempty" yaml:"GetVersionResult,omitempty"`
}

// Identity was auto-generated from WSDL.
type Identity struct {
	Password *string `xml:"Password,omitempty" json:"Password,omitempty" yaml:"Password,omitempty"`
	SystemId *string `xml:"SystemId,omitempty" json:"SystemId,omitempty" yaml:"SystemId,omitempty"`
}

// MessageInfo was auto-generated from WSDL.
type MessageInfo struct {
	CreationDate *DateTime           `xml:"cover:CreationDate,omitempty" json:"CreationDate,omitempty" yaml:"CreationDate,omitempty"`
	Creator      *MessageCreator     `xml:"cover:Creator,omitempty" json:"Creator,omitempty" yaml:"Creator,omitempty"`
	Format       *DataTransferFormat `xml:"cover:Format,omitempty" json:"Format,omitempty" yaml:"Format,omitempty"`
	FromOrgId    *string             `xml:"cover:FromOrgId,omitempty" json:"FromOrgId,omitempty" yaml:"FromOrgId,omitempty"`
	FromSysId    *string             `xml:"cover:FromSysId,omitempty" json:"FromSysId,omitempty" yaml:"FromSysId,omitempty"`
	MessageId    *string             `xml:"cover:MessageId,omitempty" json:"MessageId,omitempty" yaml:"MessageId,omitempty"`
	SessionId    *int64              `xml:"cover:SessionId,omitempty" json:"SessionId,omitempty" yaml:"SessionId,omitempty"`
	Size         *int64              `xml:"cover:Size,omitempty" json:"Size,omitempty" yaml:"Size,omitempty"`
	ToOrgId      *string             `xml:"cover:ToOrgId,omitempty" json:"ToOrgId,omitempty" yaml:"ToOrgId,omitempty"`
	ToSysId      *string             `xml:"cover:ToSysId,omitempty" json:"ToSysId,omitempty" yaml:"ToSysId,omitempty"`
	Type         *MessageType        `xml:"cover:Type,omitempty" json:"Type,omitempty" yaml:"Type,omitempty"`
}

// MessageValidationInfo was auto-generated from WSDL.
type MessageValidationInfo struct {
	Hash      *string      `xml:"cover:Hash,omitempty" json:"Hash,omitempty" yaml:"Hash,omitempty"`
	Session   *SessionInfo `xml:"cover:Session,omitempty" json:"Session,omitempty" yaml:"Session,omitempty"`
	Signature *[]byte      `xml:"cover:Signature,omitempty" json:"Signature,omitempty" yaml:"Signature,omitempty"`
}

// OpenDownloadingSession was auto-generated from WSDL.
type OpenDownloadingSession struct {
	Identity  *Identity `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	MessageId *string   `xml:"messageId,omitempty" json:"messageId,omitempty" yaml:"messageId,omitempty"`
}

// OpenDownloadingSessionResponse was auto-generated from WSDL.
type OpenDownloadingSessionResponse struct {
	OpenDownloadingSessionResult *SessionInfo `xml:"tem:OpenDownloadingSessionResult,omitempty" json:"OpenDownloadingSessionResult,omitempty" yaml:"OpenDownloadingSessionResult,omitempty"`
}

// OpenUploadingSession was auto-generated from WSDL.
type OpenUploadingSession struct {
	Identity    *Identity    `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	MessageInfo *MessageInfo `xml:"messageInfo,omitempty" json:"messageInfo,omitempty" yaml:"messageInfo,omitempty"`
	Hash        *string      `xml:"hash,omitempty" json:"hash,omitempty" yaml:"hash,omitempty"`
	Signature   *[]byte      `xml:"signature,omitempty" json:"signature,omitempty" yaml:"signature,omitempty"`
}

// OpenUploadingSessionResponse was auto-generated from WSDL.
type OpenUploadingSessionResponse struct {
	OpenUploadingSessionResult *SessionInfo `xml:"tem:OpenUploadingSessionResult,omitempty" json:"OpenUploadingSessionResult,omitempty" yaml:"OpenUploadingSessionResult,omitempty"`
}

// SessionInfo was auto-generated from WSDL.
type SessionInfo struct {
	Error                 *CommunicationError `xml:"cover:Error,omitempty" json:"Error,omitempty" yaml:"Error,omitempty"`
	MaxPartSize           *int                `xml:"cover:MaxPartSize,omitempty" json:"MaxPartSize,omitempty" yaml:"MaxPartSize,omitempty"`
	MessageId             *string             `xml:"cover:MessageId,omitempty" json:"MessageId,omitempty" yaml:"MessageId,omitempty"`
	MessageSize           *int64              `xml:"cover:MessageSize,omitempty" json:"MessageSize,omitempty" yaml:"MessageSize,omitempty"`
	SessionId             *int64              `xml:"cover:SessionId,omitempty" json:"SessionId,omitempty" yaml:"SessionId,omitempty"`
	Status                *SessionStatus      `xml:"cover:Status,omitempty" json:"Status,omitempty" yaml:"Status,omitempty"`
	TransferredBytesCount *int64              `xml:"cover:TransferredBytesCount,omitempty" json:"TransferredBytesCount,omitempty" yaml:"TransferredBytesCount,omitempty"`
	Type                  *SessionType        `xml:"cover:Type,omitempty" json:"Type,omitempty" yaml:"Type,omitempty"`
}

// UploadMessageChunk was auto-generated from WSDL.
type UploadMessageChunk struct {
	Identity     *Identity `xml:"identity,omitempty" json:"identity,omitempty" yaml:"identity,omitempty"`
	SessionId    *int64    `xml:"sessionId,omitempty" json:"sessionId,omitempty" yaml:"sessionId,omitempty"`
	MessageChunk *[]byte   `xml:"messageChunk,omitempty" json:"messageChunk,omitempty" yaml:"messageChunk,omitempty"`
}

// UploadMessageChunkResponse was auto-generated from WSDL.
type UploadMessageChunkResponse struct {
	UploadMessageChunkResult *SessionInfo `xml:"tem:UploadMessageChunkResult,omitempty" json:"UploadMessageChunkResult,omitempty" yaml:"UploadMessageChunkResult,omitempty"`
}

// Operation wrapper for DownloadMessageChunk.
// OperationICoverIntegrationService_DownloadMessageChunk_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_DownloadMessageChunk_InputMessage struct {
	DownloadMessageChunk *DownloadMessageChunk `xml:"DownloadMessageChunk,omitempty" json:"DownloadMessageChunk,omitempty" yaml:"DownloadMessageChunk,omitempty"`
}

// Operation wrapper for DownloadMessageChunk.
// OperationICoverIntegrationService_DownloadMessageChunk_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_DownloadMessageChunk_OutputMessage struct {
	DownloadMessageChunkResponse *DownloadMessageChunkResponse `xml:"DownloadMessageChunkResponse,omitempty" json:"DownloadMessageChunkResponse,omitempty" yaml:"DownloadMessageChunkResponse,omitempty"`
}

// Operation wrapper for EndProcessingDownloadedMessage.
// OperationICoverIntegrationService_EndProcessingDownloadedMessage_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_EndProcessingDownloadedMessage_InputMessage struct {
	EndProcessingDownloadedMessage *EndProcessingDownloadedMessage `xml:"EndProcessingDownloadedMessage,omitempty" json:"EndProcessingDownloadedMessage,omitempty" yaml:"EndProcessingDownloadedMessage,omitempty"`
}

// Operation wrapper for EndProcessingDownloadedMessage.
// OperationICoverIntegrationService_EndProcessingDownloadedMessage_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_EndProcessingDownloadedMessage_OutputMessage struct {
	EndProcessingDownloadedMessageResponse *EndProcessingDownloadedMessageResponse `xml:"EndProcessingDownloadedMessageResponse,omitempty" json:"EndProcessingDownloadedMessageResponse,omitempty" yaml:"EndProcessingDownloadedMessageResponse,omitempty"`
}

// Operation wrapper for GetHistory.
// OperationICoverIntegrationService_GetHistory_InputMessage was
// auto-generated from WSDL.
type OperationICoverIntegrationService_GetHistory_InputMessage struct {
	GetHistory *GetHistory `xml:"GetHistory,omitempty" json:"GetHistory,omitempty" yaml:"GetHistory,omitempty"`
}

// Operation wrapper for GetHistory.
// OperationICoverIntegrationService_GetHistory_OutputMessage was
// auto-generated from WSDL.
type OperationICoverIntegrationService_GetHistory_OutputMessage struct {
	GetHistoryResponse *GetHistoryResponse `xml:"GetHistoryResponse,omitempty" json:"GetHistoryResponse,omitempty" yaml:"GetHistoryResponse,omitempty"`
}

// Operation wrapper for GetInputMessages.
// OperationICoverIntegrationService_GetInputMessages_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_GetInputMessages_InputMessage struct {
	GetInputMessages *GetInputMessages `xml:"GetInputMessages,omitempty" json:"GetInputMessages,omitempty" yaml:"GetInputMessages,omitempty"`
}

// Operation wrapper for GetInputMessages.
// OperationICoverIntegrationService_GetInputMessages_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_GetInputMessages_OutputMessage struct {
	GetInputMessagesResponse *GetInputMessagesResponse `xml:"GetInputMessagesResponse,omitempty" json:"GetInputMessagesResponse,omitempty" yaml:"GetInputMessagesResponse,omitempty"`
}

// Operation wrapper for GetMessageValidationInfo.
// OperationICoverIntegrationService_GetMessageValidationInfo_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_GetMessageValidationInfo_InputMessage struct {
	GetMessageValidationInfo *GetMessageValidationInfo `xml:"GetMessageValidationInfo,omitempty" json:"GetMessageValidationInfo,omitempty" yaml:"GetMessageValidationInfo,omitempty"`
}

// Operation wrapper for GetMessageValidationInfo.
// OperationICoverIntegrationService_GetMessageValidationInfo_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_GetMessageValidationInfo_OutputMessage struct {
	GetMessageValidationInfoResponse *GetMessageValidationInfoResponse `xml:"GetMessageValidationInfoResponse,omitempty" json:"GetMessageValidationInfoResponse,omitempty" yaml:"GetMessageValidationInfoResponse,omitempty"`
}

// Operation wrapper for GetSessionInfo.
// OperationICoverIntegrationService_GetSessionInfo_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_GetSessionInfo_InputMessage struct {
	GetSessionInfo *GetSessionInfo `xml:"GetSessionInfo,omitempty" json:"GetSessionInfo,omitempty" yaml:"GetSessionInfo,omitempty"`
}

// Operation wrapper for GetSessionInfo.
// OperationICoverIntegrationService_GetSessionInfo_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_GetSessionInfo_OutputMessage struct {
	GetSessionInfoResponse *GetSessionInfoResponse `xml:"GetSessionInfoResponse,omitempty" json:"GetSessionInfoResponse,omitempty" yaml:"GetSessionInfoResponse,omitempty"`
}

// Operation wrapper for GetSessionsInfo.
// OperationICoverIntegrationService_GetSessionsInfo_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_GetSessionsInfo_InputMessage struct {
	GetSessionsInfo *GetSessionsInfo `xml:"GetSessionsInfo,omitempty" json:"GetSessionsInfo,omitempty" yaml:"GetSessionsInfo,omitempty"`
}

// Operation wrapper for GetSessionsInfo.
// OperationICoverIntegrationService_GetSessionsInfo_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_GetSessionsInfo_OutputMessage struct {
	GetSessionsInfoResponse *GetSessionsInfoResponse `xml:"GetSessionsInfoResponse,omitempty" json:"GetSessionsInfoResponse,omitempty" yaml:"GetSessionsInfoResponse,omitempty"`
}

// Operation wrapper for GetVersion.
// OperationICoverIntegrationService_GetVersion_InputMessage was
// auto-generated from WSDL.
type OperationICoverIntegrationService_GetVersion_InputMessage struct {
	GetVersion *GetVersion `xml:"GetVersion,omitempty" json:"GetVersion,omitempty" yaml:"GetVersion,omitempty"`
}

// Operation wrapper for GetVersion.
// OperationICoverIntegrationService_GetVersion_OutputMessage was
// auto-generated from WSDL.
type OperationICoverIntegrationService_GetVersion_OutputMessage struct {
	GetVersionResponse *GetVersionResponse `xml:"GetVersionResponse,omitempty" json:"GetVersionResponse,omitempty" yaml:"GetVersionResponse,omitempty"`
}

// Operation wrapper for OpenDownloadingSession.
// OperationICoverIntegrationService_OpenDownloadingSession_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_OpenDownloadingSession_InputMessage struct {
	OpenDownloadingSession *OpenDownloadingSession `xml:"OpenDownloadingSession,omitempty" json:"OpenDownloadingSession,omitempty" yaml:"OpenDownloadingSession,omitempty"`
}

// Operation wrapper for OpenDownloadingSession.
// OperationICoverIntegrationService_OpenDownloadingSession_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_OpenDownloadingSession_OutputMessage struct {
	OpenDownloadingSessionResponse *OpenDownloadingSessionResponse `xml:"OpenDownloadingSessionResponse,omitempty" json:"OpenDownloadingSessionResponse,omitempty" yaml:"OpenDownloadingSessionResponse,omitempty"`
}

// Operation wrapper for OpenUploadingSession.
// OperationICoverIntegrationService_OpenUploadingSession_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_OpenUploadingSession_InputMessage struct {
	OpenUploadingSession *OpenUploadingSession `xml:"OpenUploadingSession,omitempty" json:"OpenUploadingSession,omitempty" yaml:"OpenUploadingSession,omitempty"`
}

// Operation wrapper for OpenUploadingSession.
// OperationICoverIntegrationService_OpenUploadingSession_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_OpenUploadingSession_OutputMessage struct {
	OpenUploadingSessionResponse *OpenUploadingSessionResponse `xml:"OpenUploadingSessionResponse,omitempty" json:"OpenUploadingSessionResponse,omitempty" yaml:"OpenUploadingSessionResponse,omitempty"`
}

// Operation wrapper for UploadMessageChunk.
// OperationICoverIntegrationService_UploadMessageChunk_InputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_UploadMessageChunk_InputMessage struct {
	UploadMessageChunk *UploadMessageChunk `xml:"UploadMessageChunk,omitempty" json:"UploadMessageChunk,omitempty" yaml:"UploadMessageChunk,omitempty"`
}

// Operation wrapper for UploadMessageChunk.
// OperationICoverIntegrationService_UploadMessageChunk_OutputMessage
// was auto-generated from WSDL.
type OperationICoverIntegrationService_UploadMessageChunk_OutputMessage struct {
	UploadMessageChunkResponse *UploadMessageChunkResponse `xml:"UploadMessageChunkResponse,omitempty" json:"UploadMessageChunkResponse,omitempty" yaml:"UploadMessageChunkResponse,omitempty"`
}

// iCoverIntegrationService implements the ICoverIntegrationService interface.
type iCoverIntegrationService struct {
	cli *soap.Client
}

// DownloadMessageChunk was auto-generated from WSDL.
func (p *iCoverIntegrationService) DownloadMessageChunk(DownloadMessageChunk *DownloadMessageChunk) (*DownloadMessageChunkResponse, error) {
	α := struct {
		OperationICoverIntegrationService_DownloadMessageChunk_InputMessage `xml:"tns:DownloadMessageChunk"`
	}{
		OperationICoverIntegrationService_DownloadMessageChunk_InputMessage{
			DownloadMessageChunk,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_DownloadMessageChunk_OutputMessage `xml:"DownloadMessageChunkResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/DownloadMessageChunk", α, &γ); err != nil {
		return nil, err
	}
	return γ.DownloadMessageChunkResponse, nil
}

// EndProcessingDownloadedMessage was auto-generated from WSDL.
func (p *iCoverIntegrationService) EndProcessingDownloadedMessage(EndProcessingDownloadedMessage *EndProcessingDownloadedMessage) (*EndProcessingDownloadedMessageResponse, error) {
	α := struct {
		OperationICoverIntegrationService_EndProcessingDownloadedMessage_InputMessage `xml:"tns:EndProcessingDownloadedMessage"`
	}{
		OperationICoverIntegrationService_EndProcessingDownloadedMessage_InputMessage{
			EndProcessingDownloadedMessage,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_EndProcessingDownloadedMessage_OutputMessage `xml:"EndProcessingDownloadedMessageResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/EndProcessingDownloadedMessage", α, &γ); err != nil {
		return nil, err
	}
	return γ.EndProcessingDownloadedMessageResponse, nil
}

// GetHistory was auto-generated from WSDL.
func (p *iCoverIntegrationService) GetHistory(GetHistory *GetHistory) (*GetHistoryResponse, error) {
	α := struct {
		OperationICoverIntegrationService_GetHistory_InputMessage `xml:"tns:GetHistory"`
	}{
		OperationICoverIntegrationService_GetHistory_InputMessage{
			GetHistory,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_GetHistory_OutputMessage `xml:"GetHistoryResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/GetHistory", α, &γ); err != nil {
		return nil, err
	}
	return γ.GetHistoryResponse, nil
}

// GetInputMessages was auto-generated from WSDL.
func (p *iCoverIntegrationService) GetInputMessages(GetInputMessages *GetInputMessages) (*GetInputMessagesResponse, error) {
	α := struct {
		OperationICoverIntegrationService_GetInputMessages_InputMessage `xml:"tns:GetInputMessages"`
	}{
		OperationICoverIntegrationService_GetInputMessages_InputMessage{
			GetInputMessages,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_GetInputMessages_OutputMessage `xml:"GetInputMessagesResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/GetInputMessages", α, &γ); err != nil {
		return nil, err
	}
	return γ.GetInputMessagesResponse, nil
}

// GetMessageValidationInfo was auto-generated from WSDL.
func (p *iCoverIntegrationService) GetMessageValidationInfo(GetMessageValidationInfo *GetMessageValidationInfo) (*GetMessageValidationInfoResponse, error) {
	α := struct {
		OperationICoverIntegrationService_GetMessageValidationInfo_InputMessage `xml:"tns:GetMessageValidationInfo"`
	}{
		OperationICoverIntegrationService_GetMessageValidationInfo_InputMessage{
			GetMessageValidationInfo,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_GetMessageValidationInfo_OutputMessage `xml:"GetMessageValidationInfoResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/GetMessageValidationInfo", α, &γ); err != nil {
		return nil, err
	}
	return γ.GetMessageValidationInfoResponse, nil
}

// GetSessionInfo was auto-generated from WSDL.
func (p *iCoverIntegrationService) GetSessionInfo(GetSessionInfo *GetSessionInfo) (*GetSessionInfoResponse, error) {
	α := struct {
		OperationICoverIntegrationService_GetSessionInfo_InputMessage `xml:"tns:GetSessionInfo"`
	}{
		OperationICoverIntegrationService_GetSessionInfo_InputMessage{
			GetSessionInfo,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_GetSessionInfo_OutputMessage `xml:"GetSessionInfoResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/GetSessionInfo", α, &γ); err != nil {
		return nil, err
	}
	return γ.GetSessionInfoResponse, nil
}

// GetSessionsInfo was auto-generated from WSDL.
func (p *iCoverIntegrationService) GetSessionsInfo(GetSessionsInfo *GetSessionsInfo) (*GetSessionsInfoResponse, error) {
	α := struct {
		OperationICoverIntegrationService_GetSessionsInfo_InputMessage `xml:"tns:GetSessionsInfo"`
	}{
		OperationICoverIntegrationService_GetSessionsInfo_InputMessage{
			GetSessionsInfo,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_GetSessionsInfo_OutputMessage `xml:"GetSessionsInfoResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/GetSessionsInfo", α, &γ); err != nil {
		return nil, err
	}
	return γ.GetSessionsInfoResponse, nil
}

// GetVersion was auto-generated from WSDL.
func (p *iCoverIntegrationService) GetVersion(GetVersion *GetVersion) (*GetVersionResponse, error) {
	α := struct {
		OperationICoverIntegrationService_GetVersion_InputMessage `xml:"tns:GetVersion"`
	}{
		OperationICoverIntegrationService_GetVersion_InputMessage{
			GetVersion,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_GetVersion_OutputMessage `xml:"GetVersionResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/GetVersion", α, &γ); err != nil {
		return nil, err
	}
	return γ.GetVersionResponse, nil
}

// OpenDownloadingSession was auto-generated from WSDL.
func (p *iCoverIntegrationService) OpenDownloadingSession(OpenDownloadingSession *OpenDownloadingSession) (*OpenDownloadingSessionResponse, error) {
	α := struct {
		OperationICoverIntegrationService_OpenDownloadingSession_InputMessage `xml:"tns:OpenDownloadingSession"`
	}{
		OperationICoverIntegrationService_OpenDownloadingSession_InputMessage{
			OpenDownloadingSession,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_OpenDownloadingSession_OutputMessage `xml:"OpenDownloadingSessionResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/OpenDownloadingSession", α, &γ); err != nil {
		return nil, err
	}
	return γ.OpenDownloadingSessionResponse, nil
}

// OpenUploadingSession was auto-generated from WSDL.
func (p *iCoverIntegrationService) OpenUploadingSession(OpenUploadingSession *OpenUploadingSession) (*OpenUploadingSessionResponse, error) {
	α := struct {
		OperationICoverIntegrationService_OpenUploadingSession_InputMessage `xml:"tns:OpenUploadingSession"`
	}{
		OperationICoverIntegrationService_OpenUploadingSession_InputMessage{
			OpenUploadingSession,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_OpenUploadingSession_OutputMessage `xml:"OpenUploadingSessionResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/OpenUploadingSession", α, &γ); err != nil {
		return nil, err
	}
	return γ.OpenUploadingSessionResponse, nil
}

// UploadMessageChunk was auto-generated from WSDL.
func (p *iCoverIntegrationService) UploadMessageChunk(UploadMessageChunk *UploadMessageChunk) (*UploadMessageChunkResponse, error) {
	α := struct {
		OperationICoverIntegrationService_UploadMessageChunk_InputMessage `xml:"tns:UploadMessageChunk"`
	}{
		OperationICoverIntegrationService_UploadMessageChunk_InputMessage{
			UploadMessageChunk,
		},
	}

	γ := struct {
		OperationICoverIntegrationService_UploadMessageChunk_OutputMessage `xml:"UploadMessageChunkResponse"`
	}{}
	if err := p.cli.RoundTripWithAction("http://tempuri.org/ICoverIntegrationService/UploadMessageChunk", α, &γ); err != nil {
		return nil, err
	}
	return γ.UploadMessageChunkResponse, nil
}
